"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var crypto_js_1 = __importDefault(require("crypto-js"));
var log_1 = require("./log");
var CryptoObjLib = crypto_js_1.default.lib;
exports.jsonFormatter = {
    stringify: function (cipherParams) {
        var jsonObj = __assign(__assign({ ct: cipherParams.ciphertext.toString(crypto_js_1.default.enc.Base64) }, (cipherParams.iv
            ? {
                iv: cipherParams.iv.toString(),
            }
            : {})), (cipherParams.salt
            ? {
                s: cipherParams.salt.toString(),
            }
            : {}));
        return JSON.stringify(jsonObj);
    },
    parse: function (jsonStr) {
        log_1.log.debug("jsonstr", jsonStr);
        var jsonObj = JSON.parse(jsonStr);
        // @todo: Fix the following error
        // Property 'CipherParams' does not exist on type '{ WordArray: { create: (v: any) => LibWordArray; random: (v: number) => WordArray; }; }'.ts(2339)
        // Extract ciphertext from json object, and create cipher params object
        var cipherParams = CryptoObjLib["CipherParams"].create({
            ciphertext: crypto_js_1.default.enc.Base64.parse(jsonObj.ct),
        });
        return __assign(__assign(__assign({}, cipherParams), (jsonObj.iv
            ? {
                iv: crypto_js_1.default.enc.Hex.parse(jsonObj.iv),
            }
            : {})), (jsonObj.s
            ? {
                salt: crypto_js_1.default.enc.Hex.parse(jsonObj.s),
            }
            : {}));
    },
};
