import CryptoJS from 'crypto-js';
import { Encoding, Options } from './types';
export declare const getEncoding: (encoding: Encoding) => Encoding;
/**
 * Generates an initial value for the encryption process.
 */
export declare const generateIv: (seed: string, encoding: Encoding, length: number) => Promise<CryptoJS.WordArray>;
/**
 * Encrypt the field.
 */
export declare const encryptField: (plainField: string, secretPassPhrase: string, providedOptions: Options) => Promise<string>;
/**
 * Decrypt the field.
 */
export declare const decryptField: (cipherField: string, secretPassPhrase: string, providedOptions: Options) => Promise<string>;
/**
 * Generates the search hash.
 */
export declare const generateSearchHash: (field: string) => CryptoJS.WordArray;
