"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var crypto_js_1 = __importDefault(require("crypto-js"));
var json_formatter_1 = require("./json-formatter");
var consts_1 = require("./consts");
// Get the encoding.
exports.getEncoding = function (encoding) {
    if (!consts_1.encodings.includes(encoding)) {
        throw new Error("Encoding must be " + consts_1.encodings + ". Yours is " + encoding);
    }
    return encoding;
};
/**
 * Generates the necessary key for the encryption.
 */
var generateKey = function (secretPassPhrase, keySize, encoding, salt) { return __awaiter(void 0, void 0, void 0, function () {
    var key;
    return __generator(this, function (_a) {
        // Check if param is valid.
        if (!consts_1.keySizes.includes(keySize)) {
            throw new Error("Key size must be " + consts_1.keySizes + ". But your keySize is " + keySize);
        }
        key = crypto_js_1.default.PBKDF2(secretPassPhrase, salt, {
            keySize: keySize
        }).toString();
        // This doesn't work as it wants an encoder not a string?
        // }).toString(getEncoding(encoding));
        return [2 /*return*/, key];
    });
}); };
/**
 * Generates an initial value for the encryption process.
 */
exports.generateIv = function (seed, encoding, length) { return __awaiter(void 0, void 0, void 0, function () {
    var key;
    return __generator(this, function (_a) {
        if ((length % 8 != 0) || length > 2048) {
            throw new Error('Length must be a multiple of 8 and less than or equal to 2048.');
        }
        key = crypto_js_1.default.SHA3(seed, { outputLength: length });
        // Following doesn't work as it wants an encoder not a string
        // const key = CryptoJS.SHA3(seed, { outputLength: length }).toString(getEncoding(encoding));
        return [2 /*return*/, key];
    });
}); };
/**
 * Encrypt the field.
 */
exports.encryptField = function (plainField, secretPassPhrase, providedOptions) { return __awaiter(void 0, void 0, void 0, function () {
    var options, key, iv, encrypted;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                options = __assign(__assign({}, consts_1.defaultOptions), providedOptions);
                return [4 /*yield*/, generateKey(secretPassPhrase, options.keySize, options.encoding, options.keySalt)];
            case 1:
                key = _a.sent();
                return [4 /*yield*/, exports.generateIv(options.seed, options.encoding, options.length)];
            case 2:
                iv = _a.sent();
                encrypted = crypto_js_1.default.AES.encrypt(plainField, key, {
                    iv: iv,
                    format: json_formatter_1.jsonFormatter
                });
                return [2 /*return*/, encrypted.toString()];
        }
    });
}); };
/**
 * Decrypt the field.
 */
exports.decryptField = function (cipherField, secretPassPhrase, providedOptions) { return __awaiter(void 0, void 0, void 0, function () {
    var options, key, decrypted;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                options = __assign(__assign({}, consts_1.defaultOptions), providedOptions);
                return [4 /*yield*/, generateKey(secretPassPhrase, options.keySize, options.encoding, options.keySalt)];
            case 1:
                key = _a.sent();
                decrypted = crypto_js_1.default.AES.decrypt(cipherField, key, {
                    format: json_formatter_1.jsonFormatter
                });
                return [2 /*return*/, decrypted.toString(crypto_js_1.default.enc.Utf8)];
        }
    });
}); };
/**
 * Generates the search hash.
 */
exports.generateSearchHash = function (field) { return crypto_js_1.default.SHA256(field); };
