"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jumblator_encryption_1 = require("./jumblator-encryption");
var lodash_1 = __importDefault(require("lodash"));
exports.fieldEncryptionPlugin = function (schema, options) {
    var _a, _b, _c, _d, _e;
    var keySize = (_a = options.keySize) !== null && _a !== void 0 ? _a : 256;
    var keySalt = (_b = options.keySalt) !== null && _b !== void 0 ? _b : "keySalt";
    var seed = (_c = options.seed) !== null && _c !== void 0 ? _c : "seed";
    var encoding = (_d = options.encoding) !== null && _d !== void 0 ? _d : "Hex";
    var length = (_e = options.length) !== null && _e !== void 0 ? _e : 512;
    var secret = options.secret;
    var providedOptions = {
        keySize: keySize,
        keySalt: keySalt,
        seed: seed,
        encoding: encoding,
        length: length,
        secret: secret,
    };
    var pathsToEncrypt = [];
    var pathsToHash = [];
    schema.eachPath(function (pathName, schemaType) {
        if (schemaType.options && schemaType.options.encrypt) {
            pathsToEncrypt.push(pathName);
        }
    });
    schema.eachPath(function (pathName, schemaType) {
        if (schemaType.options && schemaType.options.searchable) {
            pathsToHash.push(pathName);
        }
    });
    pathsToEncrypt.forEach(function (path) {
        var _a, _b;
        var pathSplit = path.split(".");
        if (pathSplit.length > 1) {
            var newPath_1 = pathSplit[0] + ".__" + pathSplit[1] + "_enc";
            schema.add((_a = {}, _a[newPath_1] = String, _a));
        }
        var newPath = "__" + path + "_enc";
        schema.add((_b = {}, _b[newPath] = String, _b));
    });
    pathsToHash.forEach(function (path) {
        var _a, _b;
        var pathSplit = path.split(".");
        if (pathSplit.length > 1) {
            var newPath_2 = pathSplit[0] + ".__" + pathSplit[1] + "_hash";
            schema.add((_a = {}, _a[newPath_2] = String, _a));
        }
        var newPath = "__" + path + "_hash";
        schema.add((_b = {}, _b[newPath] = String, _b));
    });
    function decryptHandler(next) {
        return __awaiter(this, void 0, void 0, function () {
            var keys, key, i, originalKey, originalKeySplitPeriod, dec, hashKey;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        keys = [];
                        for (key in next) {
                            if (/^__[A-Za-z]+_enc/.test(key)) {
                                keys.push(key);
                            }
                        }
                        pathsToEncrypt.forEach(function (path) {
                            var keySplit = path.split(".");
                            if (keySplit.length > 1) {
                                for (var nextKey in next) {
                                    if (nextKey === keySplit[0]) {
                                        keys.push(nextKey + ".__" + keySplit[1] + "_enc");
                                    }
                                }
                            }
                        });
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < keys.length)) return [3 /*break*/, 5];
                        originalKey = keys[i].split("_")[2];
                        originalKeySplitPeriod = keys[i].split(".");
                        dec = void 0;
                        if (!lodash_1.default.get(next, keys[i])) return [3 /*break*/, 3];
                        return [4 /*yield*/, jumblator_encryption_1.decryptField(lodash_1.default.get(next, keys[i]), options.secret, providedOptions)];
                    case 2:
                        dec = _a.sent();
                        _a.label = 3;
                    case 3:
                        lodash_1.default.set(next, originalKey, dec);
                        hashKey = "__" + originalKey + "_hash";
                        if (originalKeySplitPeriod.length > 1) {
                            hashKey =
                                originalKeySplitPeriod[0] +
                                    ".__" +
                                    originalKeySplitPeriod[1].split("_")[2] +
                                    "_hash";
                        }
                        lodash_1.default.set(next, hashKey, undefined);
                        lodash_1.default.set(next, keys[i], undefined);
                        _a.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 1];
                    case 5: return [2 /*return*/];
                }
            });
        });
    }
    function updateHandler() {
        return __awaiter(this, void 0, void 0, function () {
            var conditions, updates, i, pathSplit, newPath, hash, j, pathSplit, newPath, enc, newPathHash, hash;
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        conditions = this._conditions;
                        updates = this._update;
                        for (i = 0; i < pathsToHash.length; i++) {
                            if (lodash_1.default.has(conditions, pathsToHash[i])) {
                                pathSplit = pathsToHash[i].split(".");
                                newPath = "__" + pathsToHash[i] + "_hash";
                                if (pathSplit.length > 1) {
                                    newPath = pathSplit[0] + ".__" + pathSplit[1] + "_hash";
                                }
                                hash = jumblator_encryption_1.generateSearchHash(conditions[pathsToHash[i]]);
                                this.where((_a = {}, _a[newPath] = hash, _a));
                                delete conditions[pathsToHash[i]];
                            }
                        }
                        j = 0;
                        _c.label = 1;
                    case 1:
                        if (!(j < pathsToEncrypt.length)) return [3 /*break*/, 5];
                        if (!lodash_1.default.has(updates, pathsToEncrypt[j])) return [3 /*break*/, 4];
                        pathSplit = pathsToEncrypt[j].split(".");
                        newPath = "__" + pathsToEncrypt[j] + "_enc";
                        if (pathSplit.length > 1) {
                            newPath = pathSplit[0] + ".__" + pathSplit[1] + "_enc";
                        }
                        enc = void 0;
                        if (!updates[pathsToEncrypt[j]]) return [3 /*break*/, 3];
                        return [4 /*yield*/, jumblator_encryption_1.encryptField(updates[pathsToEncrypt[j]], options.secret, providedOptions)];
                    case 2:
                        enc = _c.sent();
                        _c.label = 3;
                    case 3:
                        newPathHash = "__" + pathsToEncrypt[j] + "_hash";
                        if (pathSplit.length > 1) {
                            newPathHash = pathSplit[0] + ".__" + pathSplit[1] + "_hash";
                        }
                        hash = jumblator_encryption_1.generateSearchHash(updates[pathsToEncrypt[j]]);
                        this.update({}, (_b = {}, _b[newPath] = enc, _b[newPathHash] = hash, _b));
                        delete updates[pathsToEncrypt[j]];
                        _c.label = 4;
                    case 4:
                        j++;
                        return [3 /*break*/, 1];
                    case 5: return [2 /*return*/];
                }
            });
        });
    }
    schema.pre("save", function (next) {
        return __awaiter(this, void 0, void 0, function () {
            var j, pathSplit, hash, hashPath, i, enc, pathSplit, encPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        for (j = 0; j < pathsToHash.length; j++) {
                            pathSplit = pathsToHash[j].split(".");
                            hash = jumblator_encryption_1.generateSearchHash(this[pathsToHash[j]]);
                            hashPath = "__" + pathsToHash[j] + "_hash";
                            if (pathSplit.length > 1) {
                                hashPath = pathSplit[0] + ".__" + pathSplit[1] + "_hash";
                                lodash_1.default.set(this, hashPath, hash.toString());
                            }
                            else {
                                this[hashPath] = hash.toString();
                            }
                        }
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < pathsToEncrypt.length)) return [3 /*break*/, 5];
                        enc = void 0;
                        if (!lodash_1.default.get(this, pathsToEncrypt[i])) return [3 /*break*/, 3];
                        return [4 /*yield*/, jumblator_encryption_1.encryptField(lodash_1.default.get(this, pathsToEncrypt[i]), options.secret, providedOptions)];
                    case 2:
                        enc = _a.sent();
                        _a.label = 3;
                    case 3:
                        pathSplit = pathsToEncrypt[i].split(".");
                        encPath = "__" + pathsToEncrypt[i] + "_enc";
                        if (pathSplit.length > 1) {
                            encPath = pathSplit[0] + ".__" + pathSplit[1] + "_enc";
                            lodash_1.default.set(this, encPath, enc);
                            lodash_1.default.unset(this, pathsToEncrypt[i]);
                        }
                        else {
                            this[encPath] = enc;
                            this[pathsToEncrypt[i]] = undefined;
                        }
                        _a.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 1];
                    case 5:
                        next();
                        return [2 /*return*/];
                }
            });
        });
    });
    schema.post("save", decryptHandler);
    schema.post("findOne", decryptHandler);
    schema.post("findOneAndUpdate", decryptHandler);
    schema.pre("findOne", function () {
        return __awaiter(this, void 0, void 0, function () {
            var conditions, i, pathSplit, hash, newPath;
            var _a;
            return __generator(this, function (_b) {
                conditions = this.find()._conditions;
                for (i = 0; i < pathsToHash.length; i++) {
                    if (Object.keys(conditions).includes(pathsToHash[i])) {
                        pathSplit = pathsToHash[i].split(".");
                        hash = jumblator_encryption_1.generateSearchHash(conditions[pathsToHash[i]]);
                        newPath = "__" + pathsToHash[i] + "_hash";
                        if (pathSplit.length > 1) {
                            newPath = pathSplit[0] + ".__" + pathSplit[1] + "_hash";
                        }
                        delete conditions[pathsToHash[i]];
                        this.where((_a = {}, _a[newPath] = hash, _a));
                    }
                }
                return [2 /*return*/];
            });
        });
    });
    schema.pre("find", function () {
        return __awaiter(this, void 0, void 0, function () {
            var conditions, i, pathSplit, hash, newPath;
            var _a;
            return __generator(this, function (_b) {
                conditions = this.find()._conditions;
                for (i = 0; i < pathsToHash.length; i++) {
                    if (lodash_1.default.has(conditions, pathsToHash[i])) {
                        pathSplit = pathsToHash[i].split(".");
                        hash = jumblator_encryption_1.generateSearchHash(conditions[pathsToHash[i]]);
                        newPath = "__" + pathsToHash[i] + "_hash";
                        if (pathSplit.length > 1) {
                            newPath = pathSplit[0] + ".__" + pathSplit[1] + "_hash";
                        }
                        delete conditions[pathsToHash[i]];
                        this.where((_a = {}, _a[newPath] = hash, _a));
                    }
                }
                return [2 /*return*/];
            });
        });
    });
    schema.post("find", function (next) {
        return __awaiter(this, void 0, void 0, function () {
            var _loop_1, j;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _loop_1 = function (j) {
                            var keys, key, i, originalKey, originalKeySplitPeriod, dec, hashKey;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        keys = [];
                                        for (key in next[j]) {
                                            if (/^__[A-Za-z]+_enc/.test(key)) {
                                                keys.push(key);
                                            }
                                        }
                                        pathsToEncrypt.forEach(function (path) {
                                            var keySplit = path.split(".");
                                            if (keySplit.length > 1) {
                                                for (var nextKey in next[j]) {
                                                    if (nextKey === keySplit[0]) {
                                                        keys.push(nextKey + ".__" + keySplit[1] + "_enc");
                                                    }
                                                }
                                            }
                                        });
                                        i = 0;
                                        _a.label = 1;
                                    case 1:
                                        if (!(i < keys.length)) return [3 /*break*/, 5];
                                        originalKey = keys[i].split("_")[2];
                                        originalKeySplitPeriod = keys[i].split(".");
                                        dec = void 0;
                                        if (!lodash_1.default.get(next[j], keys[i])) return [3 /*break*/, 3];
                                        return [4 /*yield*/, jumblator_encryption_1.decryptField(lodash_1.default.get(next[j], keys[i]), options.secret, providedOptions)];
                                    case 2:
                                        dec = _a.sent();
                                        _a.label = 3;
                                    case 3:
                                        lodash_1.default.set(next[j], originalKey, dec);
                                        hashKey = "__" + originalKey + "_hash";
                                        if (originalKeySplitPeriod.length > 1) {
                                            hashKey =
                                                originalKeySplitPeriod[0] +
                                                    ".__" +
                                                    originalKeySplitPeriod[1].split("_")[2] +
                                                    "_hash";
                                        }
                                        lodash_1.default.set(next[j], hashKey, undefined);
                                        lodash_1.default.set(next[j], keys[i], undefined);
                                        _a.label = 4;
                                    case 4:
                                        i++;
                                        return [3 /*break*/, 1];
                                    case 5: return [2 /*return*/];
                                }
                            });
                        };
                        j = 0;
                        _a.label = 1;
                    case 1:
                        if (!(j < next.length)) return [3 /*break*/, 4];
                        return [5 /*yield**/, _loop_1(j)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        j++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    });
    schema.pre("findOneAndUpdate", updateHandler);
    schema.pre("updateOne", updateHandler);
    schema.pre("update", updateHandler);
    schema.pre("updateMany", updateHandler);
    schema.post("findOneAndUpdate", decryptHandler);
    schema.post("updateOne", decryptHandler);
    schema.post("update", decryptHandler);
    schema.post("updateMany", decryptHandler);
};
