"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = __importDefault(require("util"));
var isTest = process.env.NODE_ENV === 'test';
var isProduction = process.env.NODE_ENV === 'production';
var Logger = /** @class */ (function () {
    function Logger() {
    }
    Logger.prototype.info = function () {
        var messages = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            messages[_i] = arguments[_i];
        }
        var message = messages[0], additionalParams = messages.slice(1);
        var logLine = util_1.default.format.apply(util_1.default, __spreadArrays([message], additionalParams));
        return isTest ? logLine : console.info(logLine);
    };
    Logger.prototype.warning = function (error) {
        var errorMessage = error instanceof Error ? (isProduction ? error.message : error.stack) : error;
        var logLine = util_1.default.format(errorMessage);
        return isTest ? logLine : console.error(logLine);
    };
    Logger.prototype.error = function (error) {
        var additionalParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            additionalParams[_i - 1] = arguments[_i];
        }
        var errorMessage = error instanceof Error ? (isProduction ? error.message : error.stack) : error;
        var logLine = util_1.default.format.apply(util_1.default, __spreadArrays([errorMessage], additionalParams));
        return isTest ? logLine : console.error(logLine);
    };
    Logger.prototype.debug = function () {
        var messages = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            messages[_i] = arguments[_i];
        }
        var message = messages[0], additionalParams = messages.slice(1);
        var logLine = util_1.default.format.apply(util_1.default, __spreadArrays([message], additionalParams));
        return (isTest || isProduction) ? logLine : console.debug(logLine);
    };
    return Logger;
}());
exports.Logger = Logger;
;
exports.log = new Logger();
